﻿using System;

namespace Ascon.AppPlugin
{
    public interface IAppMain
    {
        void Client_CreateFile(string targetFile, int idCheckout, int idVersion, string fileName);
        void Client_DeleteFile(int idCheckout, int idVersion, string fileName);
        void Client_UpdateFile(string targetFile, int idCheckout, int idVersion, string fileName);
        string Client_GetFilePath(int idVersion, string stFileName);
        string Client_GetFile(int idCheckout, string stTypeObj, string stProduct, string stVersion, string stFileName, string stLocalName, int inSize, int inCRC, DateTime dtCreate, DateTime dtModify, bool revertLocalChanges);
        string Client_GetFileById(int idCheckout, int idVersion, string stFileName, string stLocalName, int inSize, int inCRC, DateTime dtCreate, DateTime dtModify, bool revertLocalChanges);
        IPluginDataSet CheckUniqueName(string stTypeName, string stProductName);
        int ExistsObject(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber,int inIdVersion);
        IPluginDataSet FindObjects(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stStateName, string stAttrCondition, string stProjects, string stLinkType);
        IPluginDataSet FindObjectsInContext2(int idCheckOut, string stContext, string stSearchXml, int inParams);
        IPluginDataSet GetAllLinkedObjects(int idCheckOut, string ids, int inParams);
        IPluginDataSet GetAttributeList();
        IPluginDataSet GetAttributesValues2(string stIds, string stAttrIds);
        IPluginDataSet GetAttrImageValueById(int idCheckOut, int inIdVersion, string stAttrName, int inIdLink);
        IPluginDataSet GetInfoAboutAttribute(string stAttrName, int inMode);
        IPluginDataSet GetInfoAboutCard(string stCardName, int inMode);
        IPluginDataSet GetInfoAboutCurrentBase(int inMode);
        IPluginDataSet GetInfoAboutCurrentUser();
        IPluginDataSet GetInfoAboutLink(int idCheckOut, int inIdLink, int inMode);
        IPluginDataSet GetInfoAboutType(string stTypeName, int inMode);
        IPluginDataSet GetInfoAboutUserSet(string stUserSet, string stDbName, int inMode);
        IPluginDataSet GetInfoAboutVersion(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, int inIdVersion, int inMode);
        IPluginDataSet GetInfoAboutVersionsFiles(int idCheckOut, string stIds);
        IPluginDataSet GetInfoAboutVersionsPrivileges(string stIds);
        IPluginDataSet GetLinkAttrForTypes(string stParentType, string stChildType, string stLinkType);
        IPluginDataSet GetLinkAttributes(int idCheckOut, int inIdLink);
        IPluginDataSet GetLinkedFast(int idCheckOut, int inIdVersion, string stLinkType, bool boInverse);
        IPluginDataSet GetLinkedFast2(int idCheckOut, int inIdVersion, string stLinkType, bool boInverse);
        IPluginDataSet GetLinkedObjects2(int idCheckOut, int inIdVersion, string stLinkType, bool boInverse, bool boFullLink, bool boGroupByProduct);
        IPluginDataSet GetLinkedObjectsAndFiles(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stLinkType, bool boFullLink, bool boViewOnlyDocuments);
        IPluginDataSet GetLinkedObjectsEx(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, int inIdVersion, string stLinkType, bool boInverse, bool boFullLink, bool boGroupByProduct);
        IPluginDataSet GetLinks(int idCheckOut, int inIdVersion1, int inIdVersion2);
        IPluginDataSet GetLObjs(int idCheckOut, int inIdVersion, bool boInverse);
        IPluginDataSet GetLockedObjects(int idCheckOut, int inParams);
        IPluginDataSet GetPrivilegesForObjects(int idCheckOut, string stIds, int mode);
        IPluginDataSet GetProjectList2(int idCheckOut, int inParams);
        IPluginDataSet GetProjectListEx(int idCheckOut, bool boWithAttrs);
        IPluginDataSet GetPropObjects2(int idCheckOut, string stObjects, int inParams);
        IPluginDataSet GetPropObjects3(int idCheckOut, string ids, string stAttrIds);
        IPluginDataSet GetStateList();
        IPluginDataSet GetTree(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, int inIdVersion, string stLinkType, bool boWithAttrs);
        IPluginDataSet GetTree2(int idCheckOut, int inIdVersion, string stLinkType, int inParams);
        IPluginDataSet GetTypeList();
        IPluginDataSet GetUserGroupList();
        IPluginDataSet GetUserList();
        IPluginDataSet GetVersionList(int idCheckOut, string stTypeName, string stProductName);
        IPluginDataSet GetVersionList2(int idCheckOut, int inIdType, string stProductName);
        int InsertObject(int idCheckOut, string stParentType, string stParentProduct, string stParentVersion, string stChildType, string stChildProduct, string stChildVersion, string stLinkType, string stState, bool boKeyInsert);
        bool IsProject(string stTypeName, string stProductName, bool boIsProject);
        void KillVersionById(int idCheckOut, int inIdVersion);
        IPluginDataSet KillVersions(int idCheckOut, string stIds, int inParams);
        int NewObject(int idCheckOut, string stTypeName, string stStateName, string stProductName, int inProject);
        void NewUserSet(string stUserSet, string stDbName, string stParentUserSet);
        IPluginDataSet OpenUserSet2(string stUserSet, int inParams);
        void UpdateStateOnObjectById(int idCheckOut, int inIdVersion, string stStateName);
        void UpFindPattern(string stFindPattern, string stUserSet, string stDBName, string stTypePattern, string stProductPattern, string stVersionPattern, string stStatePattern, string stAttrCondition, string stProjectPattern, int idPattern, bool boActive, bool boDel);
        void UpGrantOnVersion(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stOrgUnitName, int inPriveleges, DateTime dtFinishTime, bool boDel);
        int UpLink(int idCheckOut, string stParentType, string stParentProduct, string stParentVersion, string stChildType, string stChildProduct, string stChildVersion, int inIdLink, string stIdUnit, bool boDel, string stLinkType);
        int UpObject(int idCheckOut, string stTypeName, string stProductName, string stNewProductName);
        int CheckOut(string stTypeName, string stProductName, string stVersionNumber, int inMode);
        void CheckIn(int idCheckOut);
        void CancelCheckOut(int idCheckOut);
        void UpAttrValue(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stAttrName, int vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValue(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stAttrName, string vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValue(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stAttrName, DateTime vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValue(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stAttrName, double vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValueById(int idCheckOut, int inIdVersion, string stAttrName, int vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValueById(int idCheckOut, int inIdVersion, string stAttrName, string vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValueById(int idCheckOut, int inIdVersion, string stAttrName, DateTime vaAttrValue, string stIdUnit, bool boDel);
        void UpAttrValueById(int idCheckOut, int inIdVersion, string stAttrName, double vaAttrValue, string stIdUnit, bool boDel);
        void UpLinkAttrValue(int idCheckOut, int inIdLink, string stAttrName, int vaAttrValue, string stIdUnit, bool boDel);
        void UpLinkAttrValue(int idCheckOut, int inIdLink, string stAttrName, string vaAttrValue, string stIdUnit, bool boDel);
        void UpLinkAttrValue(int idCheckOut, int inIdLink, string stAttrName, DateTime vaAttrValue, string stIdUnit, bool boDel);
        void UpLinkAttrValue(int idCheckOut, int inIdLink, string stAttrName, double vaAttrValue, string stIdUnit, bool boDel);
        string GetDBList();
        IPluginDataSet GetSignatures(int aIdCheckout, int aVersionId);
        IPluginDataSet GetAnnotations(int aIdCheckout, int aVersionId);
        void SetUserSetPattern(string userSetName, string dbName, string xmlPattern);
        void UpUserSet(string stUserSet, string stDBName, string stNewUserSet, string stGroupName, int inGroupOperation, bool boDel);
        IPluginDataSet GetReport(int idCheckOut, string reportName, string Params);
        int NewVersionEx(int idCheckOut, string stTypeName, string stProductName, string stVersionNumber, string stStateName, string vaFileList, int inGroup, int inParams);
        void Loodsman_ExtractFile(int idCheckout, string typeObj, string product, string version, int idVersion, string stFileName, string stLocalName, int inSize, int inCRC, DateTime dtCreate, DateTime dtModify, string targetFile);
    }
}
