﻿namespace Ascon.AppPlugin
{
    public interface IAppProvider
    {
        string GetAppTitle();
        int GetAppHandle();

        IAppMain AppMain { get; }
        IAppWorkFlow AppWorkFlow { get; }
        IAppCache AppCache { get; }
        IAppConfigurator AppConfigurator { get; }
        
        IPluginPDMVersions GetSelectedObjects();
        void RefreshVersion(int idVersion);
        void SelectObject(int idVersion);
        void SelectTask(int idProcess, TTasksFilterExp TasksFilter);
        void SelectMail(int idLetter, TMailFilterExp Filter);

        IPluginTasks GetSelectedTasks();
        TModalResultExp GetAttachFromDlg(out IPluginPDMVersions Versions);
        TModalResultExp GetUsersFromDlg(bool ADateVisible, bool ASignRoleVisible, bool AMultiselect, bool ACan_I_Am,
                IPluginUsers ASelectedUsers, out IPluginUsers User);
        void RefreshTasks(int ASelectedRouteId);
    }
}
