unit PluginIntf;

interface

type
  //     
  TCallResult = (
                      crOk,
                      crError,
                      crStop
                      );

  //    
  TAccessLevelExp = (
                      alUndefined,
                      alNoAccess,
                      alReadOnly,
                      alReadWrite,
                      alAdministration
                      );

  //      ""
  TTasksFilterExp = (
                      tfActual,
                      tfPlanned,
                      tfSend,
                      tfIncomming,
                      tfOverdue,
                      tfCompleted,
                      tfRevoked,
                      tfAll
                      );

  //      ""
  TMailFilterExp = (
                      mkIncoming,       //  
                      mkMailed,         // 
                      mkDeleted         // 
                      );

  TBProcessKindExp = (
                      bpkTask,
                      bpkTaskAgree,
                      bpkTaskFamiliarization,
                      bpkPluginTask,    //  :      "{0700000000} "
                                        //         
                                        // 
                      bpkUnknown
                      );

  TTaskKindExp = (
                  tkIncomming,
                  tkOutgoing
                  );

  TTaskStateExp = (
                   tsUnknown,
                   tsPlanned,
                   tsSend,
                   tsInWork,
                   tsRevoked,
                   tsInChecked,
                   tsComleted
                   );

  TModalResultExp = (
                        mreNone,
                        mreOk,
                        mreCancel
                        );

//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------

  IPluginPDMVersion = interface
  ['{2B739FCC-2C99-429E-8BC8-7FBED03C8832}']
    function get_IdVersion: Integer; safecall;
    function get_IdCheckout: Integer; safecall;
    function get_AccessLevel: TAccessLevelExp; safecall;
    function get_Product: WideString; safecall;
    function get_TypeObj: WideString; safecall;
    function get_Version: WideString; safecall;
    function get_State: WideString; safecall;

    property IdVersion: Integer read get_IdVersion;
    property IdCheckout: Integer read get_IdCheckout;
    property AccessLevel: TAccessLevelExp read get_AccessLevel;
    property Product: WideString read get_Product;
    property TypeObj: WideString read get_TypeObj;
    property Version: WideString read get_Version;
    property State: WideString read get_State;

    function Title: WideString; safecall;
    function TitleAttrValue(Name: WideString): WideString; safecall;
  end;

  IPluginPDMVersions = interface
  ['{0B456EB1-794D-4796-BB9F-63EC63DBF8CA}']
    function get_Count: Integer; safecall;
    property Count: Integer read get_Count;
    function Version(Index: Integer): IPluginPDMVersion; safecall;
  end;

  IPluginDataSet = interface
  ['{B2DC9772-CF76-4F20-B423-25B62CEBC321}']
    function get_RecordCount: Integer; safecall;
    function get_Filter: WideString; safecall;
    procedure set_Filter(const Value: WideString); safecall;
    function get_Eof: WordBool; safecall;
    function get_Filtered: WordBool; safecall;
    procedure set_Filtered(const Value: WordBool); safecall;
    function get_FieldCount: Integer; safecall;

    property RecordCount: Integer read get_RecordCount;
    property Filter: WideString read get_Filter write set_Filter;
    property Filtered: WordBool read get_Filtered write set_Filtered;
    property Eof: WordBool read get_Eof;
    property FieldCount: Integer read get_FieldCount;

    function Field(index: Integer): WideString; safecall;

    procedure First; safecall;
    procedure Next; safecall;
    procedure Last; safecall;
    function Locate(const KeyFields, KeyValues: WideString): WordBool; safecall;

    function AsString(const FieldName: WideString): WideString; safecall;
    function AsInteger(const FieldName: WideString): Integer; safecall;
    function AsDateTime(const FieldName: WideString): TDateTime; safecall;
    function AsFloat(const FieldName: WideString): Double; safecall;
  end;

  //     ,    
  IPluginAppCache = interface
  ['{4EF6FD95-63AD-4E73-B028-B9AE93B74295}']
    function GetLastError: WideString; safecall;
    function GetDBName: WideString; safecall;
    function GetUserName: WideString; safecall;
    function GetUserFullName: WideString; safecall;

    function GetTypes(out ds: IPluginDataSet): WordBool; safecall;
    function GetStates(out ds: IPluginDataSet): WordBool; safecall;
    function GetDBProperties(out ds: IPluginDataSet): WordBool; safecall;
    function GetLinks(out ds: IPluginDataSet): WordBool; safecall;
    function GetAttributeList(out ds: IPluginDataSet): WordBool; safecall;
    function GetUserList(out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutType(const TypeName: WideString; inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    /// <summary>  GetLinkAttrForTypes.</summary>
    /// <returns>      .</returns>
    function GetLinkAttrForTypes(const ParentType, TypeObj, LinkType: WideString; out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutCard(const CardName: WideString; inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutAttribute(const AttrName: WideString; inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutCurrentBase(inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;

    function GetDefaultLink(const TypeName, ParentTypeName: WideString; out res: WideString): WordBool; safecall;
    function GetDefaultState(const TypeName: WideString; out res: WideString): WordBool; safecall;

    /// <summary>    .</summary>
    /// <param name="TypeObj"> .</param>
    /// <returns>True -    .</returns>
    function IsDocument(const TypeObj: WideString; out res: WordBool): WordBool; overload; safecall;
    /// <summary>    .</summary>
    /// <param name="TypeId"> .</param>
    /// <returns>True -    .</returns>
    function IsDocument(TypeId: Integer; out res: WordBool): WordBool; overload; safecall;
    function GetTypeNameById(Id: Integer; out res: WideString): WordBool; safecall;
    function GetStateNameById(Id: Integer; out res: WideString): WordBool; safecall;
    function GetLinkNameById(Id: Integer; out res: WideString): WordBool; safecall;
    function LoadPDMVersionsByIds(AIds: WideString; out res: IPluginPDMVersions): WordBool; safecall;

    function GetAutoOperationList(out ds: IPluginDataSet): WordBool; safecall;
  end;

  IPluginAppMain = interface
  ['{E7595DD5-57E1-4F14-BDE0-2F662DDDB17A}']
    function GetLastError: WideString; safecall;

    // API-    
    function Client_CreateFile(TargetFile: WideString; IdCheckout, IdVersion: Integer;
      FileName: WideString): WordBool; safecall;
    function Client_DeleteFile(IdCheckout, IdVersion: Integer;
      FileName: WideString): WordBool; safecall;
    function Client_UpdateFile(TargetFile: WideString; IdCheckout, IdVersion: Integer;
      FileName: WideString): WordBool; safecall;
    function Client_GetFilePath(IdVersion: Integer; stFileName: WideString;
      out path: WideString): WordBool; safecall;
    function Client_GetFile(IdCheckout: Integer; stTypeObj, stProduct, stVersion,
      stFileName, stLocalName: WideString; inSize, inCRC: Integer;
      dtCreate, dtModify: TDateTime; RevertLocalChanges: WordBool;
      out path: WideString): WordBool; safecall;
    function Client_GetFileById(IdCheckout, IdVersion: Integer;
      stFileName, stLocalName: WideString; inSize, inCRC: Integer;
      dtCreate, dtModify: TDateTime; RevertLocalChanges: WordBool;
      out path: WideString): WordBool; safecall;

    // API-
    function CheckUniqueName(stTypeName, stProductName: WideString;
      out ds: IPluginDataSet): WordBool; safecall;
    function ExistsObject(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber: WideString; inIdVersion: Integer;
      out res: Integer): WordBool; safecall;
    function FindObjects(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stStateName, stAttrCondition, stProjects,
      stLinkType: WideString; out ds: IPluginDataSet): WordBool; safecall;
    function FindObjectsInContext2(IdCheckOut: Integer;
      stContext, stSearchXML: WideString; inParams: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetAllLinkedObjects(IdCheckOut: Integer; Ids: WideString;
      inParams: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetAttributeList(out ds: IPluginDataSet): WordBool; safecall;
    function GetAttributesValues2(stIds, stAttrIds: WideString;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetAttrImageValueById(IdCheckOut, inIdVersion: Integer;
      stAttrName: WideString; inIdLink: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutAttribute(stAttrName: WideString; inMode: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutCard(stCardName: WideString; inMode: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutCurrentBase(inMode: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutCurrentUser(out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutLink(IdCheckOut, inIdLink, inMode: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutType(stTypeName: WideString; inMode: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutUserSet(stUserSet, stDBName: WideString;
      inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutVersion(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber: WideString; inIdVersion, inMode: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutVersionsFiles(IdCheckOut: Integer; stIds: WideString;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutVersionsPrivileges(stIds: WideString;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkAttrForTypes(stParentType, stChildType,
      stLinkType: WideString; out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkAttributes(IdCheckOut, inIdLink: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedFast(IdCheckOut, inIdVersion: Integer; stLinkType: WideString;
      boInverse: WordBool; out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedFast2(IdCheckOut, inIdVersion: Integer; stLinkType: WideString;
      boInverse: WordBool; out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedObjects2(IdCheckOut, inIdVersion: Integer;
      stLinkType: WideString; boInverse, boFullLink, boGroupByProduct: WordBool;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedObjectsAndFiles(IdCheckOut: Integer;
      stTypeName, stProductName, stVersionNumber, stLinkType: WideString;
      boFullLink, boViewOnlyDocuments: WordBool;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedObjectsEx(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber: WideString; inIdVersion: Integer; stLinkType: WideString;
      boInverse, boFullLink, boGroupByProduct: WordBool;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLinks(IdCheckOut, inIdVersion1, inIdVersion2: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLObjs(IdCheckOut, inIdVersion: Integer; boInverse: WordBool;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetLockedObjects(IdCheckOut, inParams: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetPrivilegesForObjects(IdCheckOut: Integer; stIds: WideString;
      Mode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetProjectList2(IdCheckOut: Integer; inParams: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetProjectListEx(IdCheckOut: Integer; boWithAttrs: WordBool;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetPropObjects2(IdCheckOut: Integer; stObjects: WideString;
      inParams: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetPropObjects3(IdCheckOut: Integer; Ids, stAttrIds: WideString;
      out ds: IPluginDataSet): WordBool; safecall;
    function GetStateList(out ds: IPluginDataSet): WordBool; safecall;
    function GetTree(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber: WideString; inIdVersion: Integer; stLinkType: WideString;
      boWithAttrs: WordBool; out ds: IPluginDataSet): WordBool; safecall;
    function GetTree2(IdCheckOut, inIdVersion: Integer; stLinkType: WideString;
      inParams: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetTypeList(out ds: IPluginDataSet): WordBool; safecall;
    function GetUserGroupList(out ds: IPluginDataSet): WordBool; safecall;
    function GetUserList(out ds: IPluginDataSet): WordBool; safecall;
    function GetVersionList(IdCheckOut: Integer; stTypeName,
      stProductName: WideString; out ds: IPluginDataSet): WordBool; safecall;
    function GetVersionList2(IdCheckOut: Integer; inIdType: Integer;
      stProductName: WideString; out ds: IPluginDataSet): WordBool; safecall;
    function InsertObject(IdCheckOut: Integer; stParentType, stParentProduct,
      stParentVersion, stChildType, stChildProduct, stChildVersion, stLinkType,
      stState: WideString; boKeyInsert: WordBool;
      out res: Integer): WordBool; safecall;
    function IsProject(stTypeName, stProductName: WideString;
      boIsProject: WordBool): WordBool; safecall;
    function KillVersionById(IdCheckOut, inIdVersion: Integer): WordBool; safecall;
    function KillVersions(IdCheckOut: Integer; stIds: WideString;
      inParams: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function NewObject(IdCheckOut: Integer; stTypeName, stStateName,
      stProductName: WideString; inProject: Integer;
      out res: Integer): WordBool; safecall;
    function NewUserSet(stUserSet, stDBName, stParentUserSet: WideString): WordBool; safecall;
    function OpenUserSet2(stUserSet: WideString; inParams: Integer;
      out ds: IPluginDataSet): WordBool; safecall;
    function UpdateStateOnObjectById(IdCheckOut, inIdVersion: Integer;
      stStateName: WideString): WordBool; safecall;
    function UpFindPattern(stFindPattern, stUserSet, stDBName, stTypePattern,
      stProductPattern, stVersionPattern, stStatePattern, stAttrCondition,
      stProjectPattern: WideString; nIdPattern: Integer;
      boActive, boDel: WordBool): WordBool; safecall;
    function UpGrantOnVersion(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stOrgUnitName: WideString; inPriveleges: Integer;
      dtFinishTime: TDateTime; boDel: WordBool): WordBool; safecall;
    function UpLink(IdCheckOut: Integer; stParentType, stParentProduct,
      stParentVersion, stChildType, stChildProduct, stChildVersion: WideString;
      inIdLink: Integer; {reMinQuantity, reMaxQuantity: Variant;} stIdUnit: WideString;
      boDel: WordBool; stLinkType: WideString;
      out res: Integer): WordBool; safecall;
    function UpObject(IdCheckOut: Integer; stTypeName, stProductName,
      stNewProductName: WideString; out res: Integer): WordBool; safecall;
    function CheckOut(stTypeName, stProductName, stVersionNumber: WideString;
      inMode: Integer; out res: Integer): WordBool; safecall;
    function CheckIn(IdCheckOut: Integer): WordBool; safecall;
    function CancelCheckOut(IdCheckOut: Integer): WordBool; safecall;
    //  ,    vaAttrValue
    function UpAttrValue(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stAttrName: WideString; vaAttrValue: Integer;
      stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function UpAttrValue(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stAttrName: WideString; vaAttrValue: WideString;
      stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function UpAttrValue(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stAttrName: WideString; vaAttrValue: TDateTime;
      stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function UpAttrValue(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stAttrName: WideString; vaAttrValue: Double;
      stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    //  ,    vaAttrValue
    function UpAttrValueById(IdCheckOut, inIdVersion: Integer;
      stAttrName: WideString; vaAttrValue: Integer; stIdUnit: WideString;
      boDel: WordBool): WordBool; overload; safecall;
    function UpAttrValueById(IdCheckOut, inIdVersion: Integer;
      stAttrName: WideString; vaAttrValue: WideString; stIdUnit: WideString;
      boDel: WordBool): WordBool; overload; safecall;
    function UpAttrValueById(IdCheckOut, inIdVersion: Integer;
      stAttrName: WideString; vaAttrValue: TDateTime; stIdUnit: WideString;
      boDel: WordBool): WordBool; overload; safecall;
    function UpAttrValueById(IdCheckOut, inIdVersion: Integer;
      stAttrName: WideString; vaAttrValue: Double; stIdUnit: WideString;
      boDel: WordBool): WordBool; overload; safecall;
    //  ,    vaAttrValue
    function UpLinkAttrValue(IdCheckOut, inIdLink: Integer; stAttrName: WideString;
      vaAttrValue: Integer; stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function UpLinkAttrValue(IdCheckOut, inIdLink: Integer; stAttrName: WideString;
      vaAttrValue: WideString; stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function UpLinkAttrValue(IdCheckOut, inIdLink: Integer; stAttrName: WideString;
      vaAttrValue: TDateTime; stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function UpLinkAttrValue(IdCheckOut, inIdLink: Integer; stAttrName: WideString;
      vaAttrValue: Double; stIdUnit: WideString; boDel: WordBool): WordBool; overload; safecall;
    function GetDBList(out res: WideString): WordBool; safecall;

    // API- -------------------------------------------------------------
    function GetSignatures(AIdCheckout, AVersionId: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetAnnotations(AIdCheckout, AVersionId: Integer; out ds: IPluginDataSet): WordBool; safecall;

    function SetUserSetPattern(userSetName, dbName, xmlPattern: WideString): WordBool; safecall;
    function UpUserSet(stUserSet, stDBName, stNewUserSet, stGroupName: WideString;
      inGroupOperation: Integer; boDel: WordBool): WordBool; safecall;
    //--------------------------------------------------------------------------

    function GetReport(IdCheckOut: Integer; ReportName, Params: WideString;
      out ds: IPluginDataSet): WordBool; safecall;

    /// <summary>    .</summary>
    /// <param name="IdCheckOut"> .</param>
    /// <param name="stTypeName"> .</param>
    /// <param name="stProductName"> .</param>
    /// <param name="stVersionNumber"> .</param>
    /// <param name="stStateName">  .</param>
    /// <param name="vaFileList"> ,      . 
    ///      ","  "|".   2- :
    ///  'file1.png, 5434\, file1.png, -5555\|file1.rtf, , file1.rtf, -55555\'
    ///      :
    ///  'file1.png, 5434\, file1.png, -5555\'
    ///             .
    /// </param>
    /// <param name="inGroup">    .</param>
    /// <param name="inParams">.</param>
    /// <returns> out res    .</returns>
    function NewVersionEx(IdCheckOut: Integer; stTypeName, stProductName,
      stVersionNumber, stStateName: WideString; vaFileList: WideString; inGroup,
      inParams: Integer; out res: Integer): WordBool; safecall;

    /// <summary>        TargetFile,
    ///  .
    /// !  Loodsman_ExtractFile    
    ///        Client_GetFileById
    /// </summary>
    function Loodsman_ExtractFile(IdCheckout: Integer; TypeObj, Product,
      Version: WideString; IdVersion: Integer;
      stFileName, stLocalName: WideString; inSize, inCRC: Integer; dtCreate, dtModify: TDateTime;
      TargetFile: WideString): WordBool; safecall;

    function PrintFileToXPS(FileName, XPSFileName: WideString): WordBool; safecall;
    function ClearTempUserDir: WordBool; safecall;
    function SignAs(const XPSFileName, Login: WideString): WordBool; safecall;

    function UpdateTextBlockAndBarcode(AIdCheckout,
      AVersionId: Integer): WordBool; safecall;

    function GetTypeStateAccess(inTypeId, inStateId: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedObjectsAttrsForObjects(IdCheckOut: Integer; stIds, stLinksTypesIds, stAttrIds: WideString;
      boInverse: WordBool; out ds: IPluginDataSet): WordBool; safecall;
    function GetLinkedObjectsForObjects(IdCheckOut: Integer; stIds, stLinksTypesIds: WideString;
      boInverse: WordBool; out ds: IPluginDataSet): WordBool; safecall;
  end;

  IPluginAppWorkFlow = interface
  ['{742671FA-F3EF-4071-89C1-466A6CCAADD1}']
    function GetLastError: WideString; safecall;

    // API-
    function CreateTask(Subj, Text: WideString; IdVersion,
      IdRole, IdUser: Integer; DatePlan: TDateTime; CriticalTerm: Integer;
      CheckResult: WordBool; Kind: TBProcessKindExp; out IdRoute: Integer): WordBool; safecall;
    function StartTask(IdRoute, IdRole, IdUser: Integer;
      Subj: WideString; DatePlan: TDateTime): WordBool; safecall;
    function CreateTaskByDialog(out IdRoute: Integer): WordBool; safecall;

    // API- WorkFlow
    function GetIncomingCorrespondence(inRetMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetOutcomingCorrespondence(inRetMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetCorrespondenceList(inID_Route: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function DelLetter(inIDLetter: Integer): WordBool; safecall;
    function GetUserList(out ds: IPluginDataSet): WordBool; safecall;
    function GetRoleTree(inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetProcessListByObject(stDBName: WideString; inPdm_Id: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetProcessListByObjectEx(inPdm_Id: Integer; stDBName: WideString; out ds: IPluginDataSet): WordBool; safecall;
    function GetInitialProcessList(out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutCurrentUser(out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutRoute(inID_Route: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetRoleListForUser(inID_User: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetTaskListForUser(inIdUser: Integer; inUserRoleMask,
      inProcessStateMask, inStageStateMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function CreateNewProcess(stDBName: WideString; inID_PDM_OBJECT: Integer;
      stRouteName: WideString; out res: Integer): WordBool; safecall;
    function DeleteProcess(inID_Route: Integer): WordBool; safecall;
    function InsUpdStageIntoBP(stTask: WideString;
      inCriticalTerm: Integer; dtDatePlan: TDateTime; inCanControl, inActive,
      inIdRole, inIdUser, inIdBProc, inCanTransform: Integer; out inIdStage,
      inTimeConstraint, inFromBPStart: Integer): WordBool; safecall;
    function AddRouteItemsSeq(inIdFirst, inIdSecond, inType: Integer): WordBool; safecall;
    function AddRouteItemsRetSeq(inIdFirst, inIdSecond: Integer): WordBool; safecall;
    function GetRoleListIntoProcess(inID_Route: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function SetStateOfProcess(inID_Route, inStateBP: Integer): WordBool; safecall;
    function InsUpdUser(stUserName, stDescr, stEMail: WideString; inIsAdmin: Integer;
      out vaIdUser: Integer): WordBool; safecall;
    function SetTaskState(inID_Route, inID_Operation, inStateTask: Integer;
      stMessageBody: WideString): WordBool; safecall;
    function SetItemState(inIdItem, inState, inAddSignature: Integer): WordBool; safecall;
    function SetItemStateInternal(inIdItem, inState: Integer): WordBool; safecall;
    function AddBPDocument(inIdRoute, inIdDoc, inIdPar: Integer): WordBool; safecall;
    function DelBPDocument(inIdRoute, inIdDoc: Integer): WordBool; safecall;
    function GetFirstItems(inIdRoute: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetNextItems(inIdItem: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function rep_ExecutedJobs(inID_Parent: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetJobsListIntoProcess(inID_Route: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetAttachDocumentListIntoProcess(inIdRoute: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function StartNextStage(inID_Route, inIdItem, inDirect: Integer): WordBool; safecall;
    function RenameProcess(inID_Route: Integer; stNewName: WideString): WordBool; safecall;
    function SetStageExecutor(inIdStage, inIdUser, inIdRole: Integer): WordBool; safecall;
    function SetStageTerm(inIdStage, inTimeLimit: Integer;
      vaPlanEnd: TDateTime; inTimeConstraint, inFromBPStart: Integer): WordBool; safecall;
    function SetStageTask(inIdStage: Integer; stTask: WideString): WordBool; safecall;
    function SetBP_PDMObject(inIdRoute, inIdPDMObject: Integer): WordBool; safecall;
    function GetTaskListForObject(inIdVersion, inProcessStateMask,
      inStageStateMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetInfoAboutStage(inIdStage: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function SendLetterByBPToUsers(inIdRoute: Integer; inIdAURole: Integer;
      vaRecipientList: IPluginDataSet; stSubj, stBody: WideString; out IdLetter: Integer): WordBool; safecall;

    function GetVariable(inIdRoute: Integer; stName: WideString; out res: Integer): WordBool; overload; safecall;
    function GetVariable(inIdRoute: Integer; stName: WideString; out res: WideString): WordBool; overload; safecall;
    function GetVariable(inIdRoute: Integer; stName: WideString; out res: TDateTime): WordBool; overload; safecall;
    function GetVariable(inIdRoute: Integer; stName: WideString; out res: Double): WordBool; overload; safecall;
    function SetVariable(inIdRoute: Integer; stName: WideString; Value: Integer; ReadOnlyForChild: WordBool): WordBool; overload; safecall;
    function SetVariable(inIdRoute: Integer; stName: WideString; Value: WideString; ReadOnlyForChild: WordBool): WordBool; overload; safecall;
    function SetVariable(inIdRoute: Integer; stName: WideString; Value: TDateTime; ReadOnlyForChild: WordBool): WordBool; overload; safecall;
    function SetVariable(inIdRoute: Integer; stName: WideString; Value: Double; ReadOnlyForChild: WordBool): WordBool; overload; safecall;

    function SendLetterByBPToOneUser(inIdRoute, inIdAURole, inIdRecRole, inIdRecUser: Integer;
        stSubj, stBody: WideString; out res: Integer): WordBool; safecall;

    function GetTypicalProcessList(inMode: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function CreateNewProcessBy(stDBName: string; inID_PDM_OBJECT: Integer; stRouteName: string; inIdBaseRoute: Integer; out res: Integer): WordBool; safecall;
    function InsUpdOpInstance(inIdOperDescr, inIsWait: Integer; inIdProc: Integer; inIdOperInst: Integer; out inIdNew: Integer): WordBool; safecall;
    function GetPrevItems(inIdItem: Integer; out ds: IPluginDataSet): WordBool; safecall;

    //   
    {procedure SetLetterRead(inIDLetter: Integer; inIdRole: Variant;
      inIsRead: Integer);
    function SetXMLImageToProcess(inID_Route: Integer; const stXML: WideString): Variant;
    procedure InsUpdAutoOperation(stName: WideString; inType, inIsAccess,
      inIsSystem: Integer; stScript: Variant; var vaIdOper: Variant);}
  end;

  IPluginAppConfigurator = interface
  ['{FE6C33C2-F27D-4B2F-9C84-C39119AC482A}']
    function GetLastError: WideString; safecall;

    // API- 
    function GetSortCase(stProfile, stType, stLink: WideString;
      inIndex: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetSortTypes(inIdCase: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetSortTree(inIdCase: Integer; out ds: IPluginDataSet): WordBool; safecall;
    function GetSortTable(inIdCase: Integer; out ds: IPluginDataSet): WordBool; safecall;
  end;

  IPluginCoolCommandsPanel = interface
  ['{BD5E8076-4E5F-44DE-8F29-1206E7CD48A5}']
    //   AddCommand2.  AddCommand  
    //     SDK
    procedure AddCommand(ACommandName, AGroupName, AImageName: WideString; AIndex: Integer); safecall;
    procedure ReinitCoolCommands; safecall;
    //        .        
    //      .
    procedure AddCommand2(ASpaceName, AGroupName, ACommandName, AImageName: WideString; AIndex: Integer); safecall;
  end;

  IPluginMainMenu = interface
  ['{A26CD0D3-F799-4A6D-83ED-CD7E3C98131E}']
    procedure AddCommand(ACaption: WideString; AIndex: Integer); safecall;
  end;

  IPluginUser = interface
  ['{6B8A03E9-786E-4868-9A7C-F5CE408D55F8}']
    function get_IdUser: Integer; safecall;
    function get_UserName: WideString; safecall;
    function get_FullUserName: WideString; safecall;
    function get_IdRole: Integer; safecall;
    function get_RoleName: WideString; safecall;
    function get_PlanDate: TDateTime; safecall;
    function get_SignRole: WideString; safecall;

    property IdUser: Integer read get_IdUser;
    property UserName: WideString read get_UserName;
    property FullUserName: WideString read get_FullUserName;
    property IdRole: Integer read get_IdRole;
    property RoleName: WideString read get_RoleName;
    property PlanDate: TDateTime read get_PlanDate;
    property SignRole: WideString read get_SignRole;
  end;

  IPluginTask = interface
  ['{1CFA5311-9369-4C48-9EA7-F5E6B7A34114}']
    function get_OperationId: Integer; safecall;
    function get_Text: WideString; safecall;
    function get_Subject: WideString; safecall;
    function get_CreateDate: TDateTime; safecall;
    function get_CompleteDate: TDateTime; safecall;
    function get_Author: WideString; safecall;
    function get_AuthorFullName: WideString; safecall;
    function get_Executor: IPluginUser; safecall;
    function get_RouteId: Integer; safecall;
    function get_State: TTaskStateExp; safecall;
    function get_Kind: TTaskKindExp; safecall;
    function get_HasAttachments: WordBool; safecall;
    function get_Accepted: WordBool; safecall;
    function get_ProcessKind: TBProcessKindExp; safecall;
    function get_IdVersion: Integer; safecall;

    property OperationId: Integer read get_OperationId;
    property Text: WideString read get_Text;
    property Subject: WideString read get_Subject;
    property CreateDate: TDateTime read get_CreateDate;
    property CompleteDate: TDateTime read get_CompleteDate;
    property Author: WideString read get_Author;
    property AuthorFullName: WideString read get_AuthorFullName;
    property Executor: IPluginUser read get_Executor;
    property RouteId: Integer read get_RouteId;
    property State: TTaskStateExp read get_State;
    property Kind: TTaskKindExp read get_Kind;
    property HasAttachments: WordBool read get_HasAttachments;
    property Accepted: WordBool read get_Accepted;
    property ProcessKind: TBProcessKindExp read get_ProcessKind;
    property IdVersion: Integer read get_IdVersion;
  end;

  IPluginTasks = interface
  ['{F98F70CF-D65D-4371-941A-7F05492EFE4B}']
    function get_Count: Integer; safecall;
    property Count: Integer read get_Count;
    function Task(Index: Integer): IPluginTask; safecall;
  end;

  IPluginUsers = interface
  ['{05DFEB40-9FAC-4B98-AA2A-DC054C4DEB54}']
    function get_Count: Integer; safecall;
    property Count: Integer read get_Count;
    function User(Index: Integer): IPluginUser; safecall;
  end;

  IPluginAppProvider = interface
  ['{2869F541-D50E-46A1-A704-91BFCE5E04D2}']
    function GetAppTitle: WideString; safecall;
    function GetAppHandle: THandle; safecall;
    function GetAppMain: IPluginAppMain; safecall;
    function GetAppWorkFlow: IPluginAppWorkFlow; safecall;
    function GetAppCache: IPluginAppCache; safecall;
    /// <summary>    .</summary>
    /// <returns>  .</returns>
    function GetSelectedObjects: IPluginPDMVersions; safecall;
    /// <summary>   .</summary>
    /// <param name="IdVersion"> .</param>
    procedure RefreshVersion(IdVersion: Integer); safecall;
    /// <summary>   .</summary>
    /// <param name="IdVersion"> .</param>
    /// <returns>  /   .</returns>
    function SelectObject(IdVersion: Integer): WordBool; safecall;
    function SelectTask(IdProcess: Integer; TasksFilter: TTasksFilterExp): WordBool; safecall;
    function SelectMail(IdLetter: Integer; Filter: TMailFilterExp): WordBool; safecall;
    /// <summary>  "API- ".</summary>
    /// <returns>  .</returns>
    function GetAppConfigurator: IPluginAppConfigurator; safecall;
    function GetSelectedTasks(out res: IPluginTasks): WordBool; safecall;
    function GetAttachFromDlg(out Versions: IPluginPDMVersions;
      out res : TModalResultExp): WordBool; safecall;
    function GetUsersFromDlg(ADateVisible, ASignRoleVisible,
      AMultiselect, ACan_I_Am: WordBool; ASelectedUsers: IPluginUsers;
      out Users: IPluginUsers; out res : TModalResultExp): WordBool; safecall;
    function RefreshTasks(ASelectedRouteId: Integer): WordBool; safecall;

    function GetLastError: WideString; safecall;
    /// <summary>  .</summary>
    /// <param name="CatalogTypeObj  CatalogProduct">   -  .</param>
    /// <param name="CheckVersions">        .</param>
    /// <param name="Versions">    .</param>
    /// <param name="res">   .</param>
    function ShowCatalogDlg(const CatalogTypeObj, CatalogProduct: WideString;
      CheckVersions: IPluginPDMVersions;
      out Versions: IPluginPDMVersions; out res: TModalResultExp): WordBool; safecall;
    function GetSelectedParentObject: IPluginPDMVersion; safecall;
  end;


//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------

  //       
  IPlugin = interface
  ['{087C9BC0-FEFD-471E-ACEF-3EF0E0BA9267}']
    function GetVersion(): Integer; safecall;
    function GetLastError(): WideString; safecall;
    procedure Init(AppProvider: IPluginAppProvider); safecall;
  end;

  //     "  "  
  IPluginCoolCommands = interface
  ['{608F0F4E-B00F-49AC-8AE2-2BCF6815D9F3}']
    procedure InitCoolCommands(ACCPanel: IPluginCoolCommandsPanel); safecall;
    procedure CallCoolCommand(AIndex: Integer); safecall;
  end;

  //       
  IPluginEvents = interface
  ['{641E6182-BEFA-4DDD-814E-99E7B6DFA02C}']
    //  AfterCreateDocument    ,   
    function AfterCreateDocument(ADocument: IPluginPDMVersion; AFile: WideString): TCallResult; safecall;
    //  AfterEditObject       ,  CheckIn
    function AfterEditObject(AParent, AObject: IPluginPDMVersion; AIdLink: Integer;
      ALinkType, ANewProduct, ANewState: WideString): TCallResult; safecall;
    function CheckAttachment(Version: IPluginPDMVersion; out RejectReason: WideString): TCallResult; safecall;
    //     .     
    //      
    function BeforeUnloadingPlugin: TCallResult; safecall;
    //        .      
	//  -  pluginTask = true
	function BeforCreateTaskInPF(AVersions: IPluginPDMVersions; out PluginTask: WordBool): TCallResult; safecall;
  end;

  IPluginMenu = interface
  ['{EBE20987-48E5-4E33-8664-66AC259F05C1}']
    procedure InitMainMenu(AMenu: IPluginMainMenu); safecall;
    procedure CallMainMenu(AIndex: Integer); safecall;
  end;


  TLoadPlugin = function (): IPlugin; safecall;


const
  //   SDK
  PLUGIN_VERSION = 20120214;
  //     
  LOAD_PLUGIN = 'LoadPlugin';
  //   TCallResult
  CallResultNames: array [TCallResult] of WideString = ('crOk', 'crError', 'crStop');

const
  //     
  cSpaceDocuments = 'SpaceDocuments';
  cSpaceTasks = 'SpaceTasks';
  //     
  cGroupObject = '    ';
  cGroupDetail = '';
  cGroupProject = '  ';
  cGroupTask = '  ';


implementation

end.
