﻿unit DlgTaskCreate;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Controls,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  ActnList,
  Dialogs,
  Forms,
  Buttons,
  ToolWin,

  PluginIntf,
  PluginIntfWrapper,
  FrameAttachments,
  MiscApp;


type
  TfrmDlgTaskCreate = class(TForm)
    ActionList1: TActionList;
    ASendTask: TAction;
    APlanTask: TAction;
    AAttach: TAction;
    pnlTop: TPanel;
    Label1: TLabel;
    edtSabj: TEdit;
    btnRecipient: TButton;
    Splitter1: TSplitter;
    pnlAttachments: TPanel;
    pnlPlanning: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Edit1: TEdit;
    edtText: TMemo;
    procedure ASendTaskExecute(Sender: TObject);
    procedure AAttachExecute(Sender: TObject);
    procedure btnRecipientClick(Sender: TObject);
  private
    { Private declarations }
    FAppProvider: TAppProvider;
    FTaskHalper: TTaskHalper;
    FFrameAttachments: TfrmFrameAttachments;
    FUsers: IPluginUsers;
    procedure LoadUsers(AUsers: IPluginUsers);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; AAppProvider: TAppProvider); reintroduce;
    destructor Destroy; override;
  end;

implementation

{$R *.dfm}

uses
  MiscGUI;

constructor TfrmDlgTaskCreate.Create(AOwner: TComponent;
  AAppProvider: TAppProvider);
begin
  inherited Create(AOwner);

  FAppProvider := AAppProvider;
  FTaskHalper := TTaskHalper.Create(FAppProvider);

  FFrameAttachments := TfrmFrameAttachments.Create(Self, FAppProvider);
  PlaceFrameToControl(FFrameAttachments, pnlAttachments);

  Edit1.ReadOnly := True;
end;

destructor TfrmDlgTaskCreate.Destroy;
begin
  FreeAndNil(FTaskHalper);
  inherited;
end;

procedure TfrmDlgTaskCreate.AAttachExecute(Sender: TObject);
begin
  FFrameAttachments.ShowDlgAttach;
end;

procedure TfrmDlgTaskCreate.ASendTaskExecute(Sender: TObject);
var
  i: Integer;
  a: Integer;
  RouteId: Integer;
begin
  RouteId := 0;

  for i := 0 to FUsers.Count-1 do
  begin
    RouteId := FAppProvider.AppWorkFlow.CreateTask(
                      edtSabj.Text,
                      edtText.Text,
                      // Первое вложение делаем как основной объект бизнес-процесса,
                      // для того, что бы можно было показать скрепочку в списке заданий
                      FTaskHalper.GetFirstIdAttachment(FFrameAttachments.GetAttachments),
                      FUsers.User(i).IdRole,
                      FUsers.User(i).IdUser,
                      FUsers.User(i).PlanDate,
                      0,
                      True,
                      bpkTask
                      );
    // добавляем доп. вложения
    for a := 0 to FFrameAttachments.Count-1 do
      FAppProvider.AppWorkFlow.AddBPDocument(RouteId, FFrameAttachments[a].IdVersion, 0);

    FAppProvider.AppWorkFlow.StartTask(
                                  RouteId,
                                  FUsers.User(i).IdRole,
                                  FUsers.User(i).IdUser,
                                  edtSabj.Text,
                                  FUsers.User(i).PlanDate);
  end;

  FAppProvider.RefreshTasks(RouteId);
  ModalResult := mrOk;
end;

procedure TfrmDlgTaskCreate.btnRecipientClick(Sender: TObject);
var
  Users: IPluginUsers;
begin
  if FAppProvider.GetUsersFromDlg(True, False, True, False, nil, Users) = mreOk then
  begin
    LoadUsers(Users);
    FUsers := Users;
  end;
end;

procedure TfrmDlgTaskCreate.LoadUsers(AUsers: IPluginUsers);
var
  i: Integer;
  Info: string;
  s: string;
begin
  s := '';
  for i := 0 to AUsers.Count-1 do
  begin
    Info := ConvertToUserTitle(AUsers.User(i).UserName, AUsers.User(i).FullUserName, False);
    if not IsNull(AUsers.User(i).PlanDate) then
      Info := Format('%s (%s)', [Info, DateToStr(AUsers.User(i).PlanDate)]);

    s := AddStringWithSeparator(s, Info, '; ');
  end;
  Edit1.Text := s
end;

end.
