unit MiscApp;

interface

uses
  Classes,

  PluginIntf,
  PluginIntfWrapper;


type
  TTaskHalper = class
  private
    FAppProvider: TAppProvider;
  public
    constructor Create(AAppProvider: TAppProvider);
    function GetFirstIdAttachment(AAttachments: IPluginPDMVersions): Integer;
    function GetProjectIdForChild(AIdVersion: Integer): Integer;
  end;

implementation

uses
  SysUtils,

  MiscGUI;


{ TTaskHalper }

constructor TTaskHalper.Create(AAppProvider: TAppProvider);
begin
  FAppProvider := AAppProvider;
end;

function TTaskHalper.GetProjectIdForChild(AIdVersion: Integer): Integer;
//       AIdVersion
const
  cfgProjectType = '';
  cfgFolderLink = ' ...';
var
  Versions: IPluginPDMVersions;
  IdTypeProject: Integer;
  dsTypes: IPluginDataSet;
  dsParents: IPluginDataSet;
begin
  Result := 0;

  if AIdVersion = 0 then
    Exit;

  // ,      
  Versions := FAppProvider.AppCache.LoadPDMVersionsByIds(IntToStr(AIdVersion));
  if Assigned(Versions) then
    if Versions.Count > 0 then
      if Versions.Version(0).TypeObj = cfgProjectType then
      begin
        Result := Versions.Version(0).IdVersion;
        Exit;
      end;

  dsTypes := FAppProvider.AppCache.GetTypes;
  if not dsTypes.Locate('_TYPENAME', cfgProjectType) then
    Exit;

  IdTypeProject :=  dsTypes.AsInteger('_ID');
  dsParents := FAppProvider.AppMain.GetLinkedObjects2(0,
                                      AIdVersion, cfgFolderLink, True, True, False);
  if dsParents.Locate('_ID_TYPE', IntToStr(IdTypeProject)) then
    Result := dsParents.AsInteger('_ID_VERSION');
end;

function TTaskHalper.GetFirstIdAttachment(AAttachments: IPluginPDMVersions): Integer;
begin
  Result := 0;

  if not Assigned(AAttachments) then
    Exit;

  if AAttachments.Count = 0 then
    Exit;

  if IsPGS(FAppProvider.GetAppTitle) then
  begin
    //  Id  ()    :
    // -         -   ,
    //   Id  ,    
    Result := GetProjectIdForChild(AAttachments.Version(0).IdVersion);
  end;

  if Result = 0 then
    Result := AAttachments.Version(0).IdVersion;
end;


end.
