unit PluginUsers;

interface

uses
  Classes,

  PluginIntf;

type
  TUserArray = array of IPluginUser;

  TPluginUsers = class(TInterfacedObject, IPluginUsers)
  private
    FUsersArray: TUserArray;
  private
    // IPluginUsers
    function get_Count: Integer; safecall;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Add(AUser: IPluginUser);
  public
    // IPluginUsers
    property Count: Integer read get_Count;
    function User(Index: Integer): IPluginUser; safecall;
  end;



implementation

uses
  SysUtils;


{ TPluginUsers }

constructor TPluginUsers.Create;
begin
  SetLength(FUsersArray, 0);
end;

destructor TPluginUsers.Destroy;
begin

  inherited;
end;

function TPluginUsers.get_Count: Integer;
begin
  Result := Length(FUsersArray);
end;

function TPluginUsers.User(Index: Integer): IPluginUser;
begin
  Result := FUsersArray[Index];
end;

procedure TPluginUsers.Add(AUser: IPluginUser);
var
  i: Integer;
begin
  i := get_Count;
  SetLength(FUsersArray, i + 1);
  FUsersArray[i] := AUser;
end;

end.
